IsoIntersectReader
Date: 2019-10-22

org.jmol.jvxl.readers

## Class IsoIntersectReader

- java.lang.Object
- - org.jmol.jvxl.readers.SurfaceReader
  - - org.jmol.jvxl.readers.VolumeDataReader
    - - org.jmol.jvxl.readers.AtomDataReader
      - - org.jmol.jvxl.readers.IsoIntersectReader

- All Implemented Interfaces:
    VertexDataServer

      class IsoIntersectReader
      extends AtomDataReader

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private javajs.util.BS[][]` | `bsAtomMinMax`
    `private java.lang.Object[]` | `func`
    `private int` | `funcType`
    `private javajs.util.BS` | `myBsA`
    `private javajs.util.BS` | `myBsB`
    `private float[]` | `thisPlaneB`
    `private static int` | `TYPE_DIFF`
    `private static int` | `TYPE_DIFF_PAIR`
    `private static int` | `TYPE_FUNCTION`
    `private static int` | `TYPE_MAX`
    `private static int` | `TYPE_SUM`
    `private float[]` | `values`

    - ### Fields inherited from class org.jmol.jvxl.readers.AtomDataReader

      `ac, atomData, atomIndex, atomNo, atomProp, atomRadius, atomXyzTruncated, bsMyIgnored, bsMySelected, bsNearby, bsSurfaceVoxels, contactPair, doAddHydrogens, doUseIterator, fileDotModel, fileName, firstNearbyAtom, haveOneProperty, havePlane, margin, maxDistance, maxRS, modelIndex, myAtomCount, myIndex, nearbyAtomCount, noFaceSpheres, pt0, pt1, ptV, ptY0, ptZ0, rs, rs2, sr, theProperty, thisAtomSet, thisPlane, thisX, validSpheres, vl0, vl1, vl2, voxelSource`

    - ### Fields inherited from class org.jmol.jvxl.readers.VolumeDataReader

      `allowMapData, dataType, maxGrid, point, precalculateVoxelData, ptsPerAngstrom, useOriginStepsPoints`

    - ### Fields inherited from class org.jmol.jvxl.readers.SurfaceReader

      `allowSigma, ANGSTROMS_PER_BOHR, anisotropy, center, cJvxlEdgeNaN, colorFractionBase, colorFractionRange, contourVertexCount, dataMax, dataMean, dataMin, defaultCutoff, defaultMappedDataMax, defaultMappedDataMin, eccentricityMatrix, eccentricityMatrixInverse, eccentricityRatio, eccentricityScale, edgeFractionBase, edgeFractionRange, fractionData, hasColorData, haveSurfaceAtoms, isAnisotropic, isEccentric, isJvxl, isPeriodic, isProgressive, isQuiet, isXLowToHigh, jvxlColorDataRead, jvxlCutoff, jvxlData, jvxlDataIs2dContour, jvxlDataIsColorDensity, jvxlDataIsColorMapped, jvxlDataIsPrecisionColor, jvxlEdgeDataRead, jvxlFileHeaderBuffer, jvxlNSurfaceInts, jvxlVoxelBitSet, marchingCubes, marchingSquares, meshData, meshDataServer, minMax, nBytes, nDataPoints, nPointsX, nPointsY, nPointsZ, params, ptTemp, qpc, sg, vertexDataOnly, volumeData, volumetricOrigin, volumetricVectors, voxelCounts, voxelData, xyzMax, xyzMin, yzCount, yzPlanes`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IsoIntersectReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `float[]` | `getPlane(int x)`
    `private float` | `getValueAB(float va, float vb)`
    `float` | `getValueAtPoint(javajs.util.T3 pt, boolean getSource)`
    `private float` | `getValueAtPoint2(javajs.util.T3 pt, javajs.util.BS bs)`
    `(package private) void` | `init(SurfaceGenerator sg)` implemented in SurfaceFileReader and
    `protected boolean` | `readVolumeParameters(boolean isMapData)`
    `protected void` | `setup(boolean isMapData)`
    `private boolean` | `setVoxels()`

    - ### Methods inherited from class org.jmol.jvxl.readers.AtomDataReader

      `getAtomMinMax, getAtoms, initADR, markPlaneVoxels, markSphereVoxels, resetPlane, resetVoxelData, setGridLimitsForAtom, setHeader, setRadii, setRanges, setup2, setVertexSource, setVolumeData, setVolumeDataADR, setVolumeForPlane, setVoxel, unsetVoxelData, unsetVoxelData2`

    - ### Methods inherited from class org.jmol.jvxl.readers.VolumeDataReader

      `closeReader, generateCube, initVDR, readSurfaceData, readSurfaceDataVDR, readVolumeData, readVoxelDataIndividually, setVolumeDataParams, setVoxelRange, showGridInfo`

    - ### Methods inherited from class org.jmol.jvxl.readers.SurfaceReader

      `addTriangleCheck, addVC, addVertexCopy, applyColorScale, colorIsosurface, createIsosurface, discardTempData, discardTempDataSR, excludeMaximumSet, excludeMinimumSet, finalizeMapping, getColorPhaseIndex, getMinMaxMappedValues, getPlaneSR, getSPF, getSurfaceAtomIndex, getSurfacePointAndFraction, getSurfacePointIndexAndFraction, getValue, getValue2, gotoAndReadVoxelData, gotoData, initializeMapping, initializeVolumetricData, initPlanes, initSR, jvxlUpdateInfo, newVoxelDataCube, postProcessVertices, readAndSetVolumeParameters, readColorData, resetIsosurface, selectPocket, setBBox, setOutputChannel, setVectorAnisotropy, setVertexAnisotropy, setVolumeDataV, setVolumetricAnisotropy, setVolumetricOriginAnisotropy, slabIsosurface, updateSurfaceData, updateTriangles`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### TYPE_FUNCTION

          private static final int TYPE_FUNCTION

      See Also:
        Constant Field Values

    - #### TYPE_SUM

          private static final int TYPE_SUM

      See Also:
        Constant Field Values

    - #### TYPE_DIFF

          private static final int TYPE_DIFF

      See Also:
        Constant Field Values

    - #### TYPE_MAX

          private static final int TYPE_MAX

      See Also:
        Constant Field Values

    - #### TYPE_DIFF_PAIR

          private static final int TYPE_DIFF_PAIR

      See Also:
        Constant Field Values

    - #### myBsA

          private final javajs.util.BS myBsA

    - #### myBsB

          private final javajs.util.BS myBsB

    - #### bsAtomMinMax

          private javajs.util.BS[][] bsAtomMinMax

    - #### func

          private java.lang.Object[] func

    - #### funcType

          private int funcType

    - #### thisPlaneB

          private float[] thisPlaneB

    - #### values

          private final float[] values

  - ### Constructor Detail

    - #### IsoIntersectReader

          IsoIntersectReader()

  - ### Method Detail

    - #### init

          void init(SurfaceGenerator sg)

      Description copied from class: `SurfaceReader`
      implemented in SurfaceFileReader and
      Overrides:
        `init` in class `VolumeDataReader`

    - #### readVolumeParameters

          protected boolean readVolumeParameters(boolean isMapData)

      Overrides:
        `readVolumeParameters` in class `VolumeDataReader`

    - #### setup

          protected void setup(boolean isMapData)

      Overrides:
        `setup` in class `AtomDataReader`

    - #### getPlane

          public float[] getPlane(int x)

      Specified by:
        `getPlane` in interface `VertexDataServer`
      Overrides:
        `getPlane` in class `SurfaceReader`

    - #### setVoxels

          private boolean setVoxels()

    - #### getValueAB

          private float getValueAB(float va,
                                   float vb)

    - #### getValueAtPoint

          public float getValueAtPoint(javajs.util.T3 pt,
                                       boolean getSource)

      Overrides:
        `getValueAtPoint` in class `SurfaceReader`
        `getSource` - TODO
      Returns:
        value

    - #### getValueAtPoint2

          private float getValueAtPoint2(javajs.util.T3 pt,
                                         javajs.util.BS bs)